"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _FormContext = require("./FormContext");

var _FormContext2 = _interopRequireDefault(_FormContext);

var _utils = require("../utilities/utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var FormFragment = function (_Component) {
  _inherits(FormFragment, _Component);

  function FormFragment(props) {
    _classCallCheck(this, FormFragment);

    var _this = _possibleConstructorReturn(this, (FormFragment.__proto__ || Object.getPrototypeOf(FormFragment)).call(this, props));

    var _props$defaultFields = props.defaultFields,
        defaultFields = _props$defaultFields === undefined ? [] : _props$defaultFields,
        registerField = props.registerField,
        _props$fields = props.fields,
        fields = _props$fields === undefined ? [] : _props$fields;

    defaultFields.forEach(function (field) {
      if (fields.find(function (existingField) {
        return existingField.id === field.id;
      })) {
        // console.warn("Fragment tried to re-register field", field.id);
      } else {
        registerField(field);
      }
    });
    return _this;
  }

  _createClass(FormFragment, [{
    key: "render",
    value: function render() {
      var _props = this.props,
          _props$defaultFields2 = _props.defaultFields,
          defaultFields = _props$defaultFields2 === undefined ? [] : _props$defaultFields2,
          fields = _props.fields,
          onFieldChange = _props.onFieldChange,
          renderer = _props.renderer,
          value = _props.value;

      var renderedFields = defaultFields.map(function (field) {
        var fieldToRender = fields.find(function (registeredField) {
          return registeredField.id === field.id;
        });
        if (fieldToRender && fieldToRender.visible) {
          var name = field.name,
              omitWhenValueIs = field.omitWhenValueIs;

          var formValueForName = value[name];
          if (omitWhenValueIs && omitWhenValueIs.find(function (targetValue) {
            return targetValue === formValueForName;
          }) === -1) {
            fieldToRender.value = field.value;
          } else {
            fieldToRender.value = (0, _utils.getFirstDefinedValue)(value[field.name], field.value);
          }
          return renderer(fieldToRender, onFieldChange);
        }
        return null;
      });

      return _react2.default.createElement(
        _react.Fragment,
        null,
        renderedFields
      );
    }
  }]);

  return FormFragment;
}(_react.Component);

exports.default = function (props) {
  return _react2.default.createElement(
    _FormContext2.default.Consumer,
    null,
    function (form) {
      return _react2.default.createElement(FormFragment, _extends({}, form, props));
    }
  );
};