"use strict";

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _enzyme = require("enzyme");

var _enzyme2 = _interopRequireDefault(_enzyme);

var _enzymeAdapterReact = require("enzyme-adapter-react-16");

var _enzymeAdapterReact2 = _interopRequireDefault(_enzymeAdapterReact);

var _Form = require("./components/Form");

var _Form2 = _interopRequireDefault(_Form);

var _Button = require("./components/Button");

var _Button2 = _interopRequireDefault(_Button);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// import FormButton from "../../atlaskit/src/components/buttons/FormButton";

// import { expect } from "chai";
_enzyme2.default.configure({ adapter: new _enzymeAdapterReact2.default() });


describe("Default renderer", function () {
  test("single text field", function () {
    var singleField = [{
      id: "FIELD1",
      name: "prop1",
      defaultValue: "test",
      type: "text"
    }];
    // NOTE: It's not possible to test components using the new React Context API yet in Enzyme,
    //       See https://github.com/airbnb/enzyme/pull/1513
    var wrapper = (0, _enzyme.mount)(_react2.default.createElement(_Form2.default, { defaultFields: singleField }));
    var inputFields = wrapper.find("input");
    expect(inputFields.length).toBe(1);
  });
});

describe("Basic single field form capabilities", function () {
  var onFormChange = jest.fn();
  var onButtonClick = jest.fn();
  var singleField = [{
    id: "FIELD1",
    name: "prop1",
    defaultValue: "test",
    type: "text"
  }];

  var wrapper = (0, _enzyme.mount)(_react2.default.createElement(
    _Form2.default,
    { defaultFields: singleField, onChange: onFormChange },
    _react2.default.createElement(_Button2.default, { onClick: onButtonClick })
  ));

  test("has single input field", function () {
    expect(wrapper.find("input[type='text']").length).toBe(1);
  });

  test("has a button", function () {
    expect(wrapper.find(_Button2.default).length).toBe(1);
  });

  var button = wrapper.find(_Button2.default);
  test("button initially has no value", function () {
    button.prop("onClick")();
    expect(onButtonClick).toHaveBeenCalledTimes(1);
    // expect(onButtonClick).toHaveBeenLastCalledWith({});
  });

  var inputField = wrapper.find("input[type='text']");
  test("changing field value calls onChange", function () {
    inputField.simulate("change", { target: { value: "test" } });
    expect(onFormChange).toHaveBeenLastCalledWith({ prop1: "test" }, true);
  });

  test("button initially has no value", function () {
    button.prop("onClick")();
    expect(onButtonClick).toHaveBeenCalledTimes(2);
    // expect(onButtonClick).toHaveBeenLastCalledWith({ prop1: "test" });
  });
});